import { LitElement as x, unsafeCSS as b, html as c, nothing as i } from "lit";
import { query as p, property as o, state as v } from "lit/decorators.js";
import { live as k } from "lit/directives/live.js";
import { FormControlMixin as u } from "@open-wc/form-control";
import { event as f } from "../../utils/event.js";
import { innerInputValidators as m } from "../../utils/validators.js";
import "../label/index.js";
const y = `:host {
  display: inline-block;

  --dfx-checkbox-border-radius: var(--dfx-border-radius-m, 0.375rem);
  --dfx-checkbox-color: var(--dfx-color-primary-dark, #0063eb);
  --dfx-checkbox-check-size: var(--dfx-size-xs, 0.75rem);
  --dfx-checkbox-focus-offset: var(--dfx-form-outline-offset, 0.2rem);
  --dfx-checkbox-font-family: var(
    --dfx-font-family,
    -apple-system,
    BlinkMacSystemFont,
    'Segoe UI',
    Roboto,
    Arial,
    sans-serif
  );
  --dfx-checkbox-font-size: var(--dfx-font-size-m, 0.875rem);
  --dfx-checkbox-gap: var(--dfx-size-2xs, 0.5rem);
  --dfx-checkbox-line-height: var(--dfx-line-height-m, 1.5);
  --dfx-checkbox-size: var(--dfx-size-l, 1.25rem);
  --dfx-checkbox-switch-size: var(--dfx-size-2xl, 2rem);
  --dfx-checkbox-transition: all var(--dfx-transition-medium, 0.2s ease-in-out);
}

:host([hidden]) {
  display: none;
}

:host([disabled]) input {
  background-color: var(--dfx-color-border-dark, #979fab);
  box-shadow: var(--dfx-form-border, inset 0 0 0 0.05rem #979fab);
  cursor: not-allowed;
}

:host([disabled]) [part='container'] {
  opacity: var(--dfx-form-disabled-opacity, 0.5);
}

label {
  display: grid;
  grid-template-columns: auto 1fr;
  gap: var(--dfx-checkbox-gap);
}

input {
  display: inline-block;
  width: var(--dfx-checkbox-size);
  height: var(--dfx-checkbox-size);
  box-sizing: border-box;
  background-color: transparent;
  box-shadow: var(--dfx-form-border, inset 0 0 0 0.05rem #979fab);
  transition: var(--dfx-checkbox-transition);
  border-radius: var(--dfx-checkbox-border-radius);
  appearance: none;
  cursor: pointer;
  border: none;
  margin: 0;

  &:checked {
    background-color: var(--dfx-checkbox-color);
    box-shadow: none;
  }

  &::after {
    --dfx-checkbox-check-color: transparent;
    --dfx-checkbox-switch-gap: calc(
      (var(--dfx-checkbox-size) - var(--dfx-checkbox-check-size)) / 2
    );
    content: '';
    display: block;
    width: var(--dfx-checkbox-check-size);
    height: var(--dfx-checkbox-check-size);
    mask-image: url('data:image/svg+xml, <svg width="12" height="12" viewBox="0 0 12 12" fill="none" xmlns="http://www.w3.org/2000/svg"><path d="M10.5546 1.16805C11.0141 1.4744 11.1383 2.09527 10.8319 2.55479L6.032 9.75471C5.86581 10.004 5.59662 10.1656 5.29849 10.1951C5.00036 10.2247 4.7047 10.119 4.49286 9.90712L1.29289 6.70715C0.90237 6.31663 0.90237 5.68347 1.29289 5.29295C1.68341 4.90243 2.31657 4.90243 2.70709 5.29295L5.04453 7.6304L9.16786 1.4454C9.47421 0.985877 10.0951 0.861705 10.5546 1.16805Z" fill="black"/></svg>');
    mask-size: contain;
    background-color: var(--dfx-checkbox-check-color);
    margin: var(--dfx-checkbox-switch-gap);
    transition: var(--dfx-checkbox-transition);
  }

  &:checked::after {
    --dfx-checkbox-check-color: var(--dfx-color-contrast-text, #ffffff);
  }

  &:focus-visible {
    outline: auto;
    outline-offset: var(--dfx-checkbox-focus-offset);
  }
}

[part='label'] {
  font-family: var(--dfx-checkbox-font-family);
  font-size: var(--dfx-checkbox-font-size);
  line-height: var(--dfx-checkbox-line-height);
}

.invalid input {
  box-shadow: var(--dfx-form-border-error, inset 0 0 0 0.05rem #c91f3a);
}

:host([type='switch']) input {
  --dfx-checkbox-border-radius: var(--dfx-border-radius-full, 62.438rem);
  width: var(--dfx-checkbox-switch-size);
}

:host([type='switch']) input::after {
  --dfx-checkbox-check-color: var(--dfx-color-border-dark, #979fab);
  mask: none;
  border-radius: var(--dfx-border-radius-full, 62.438rem);
}

:host([type='switch']) input:checked::after {
  --dfx-checkbox-check-color: var(--dfx-color-contrast-text, #ffffff);
  transform: translateX(
    calc(
      var(--dfx-checkbox-switch-size) - var(--dfx-checkbox-check-size) -
        (var(--dfx-checkbox-switch-gap) * 2)
    )
  );
}

:host([type='switch']):host([disabled]) input::after {
  --dfx-checkbox-check-color: var(--dfx-color-contrast-text, #ffffff);
}
`;
var g = Object.defineProperty, w = Object.getOwnPropertyDescriptor, e = (s, r, d, a) => {
  for (var n = a > 1 ? void 0 : a ? w(r, d) : r, h = s.length - 1, l; h >= 0; h--)
    (l = s[h]) && (n = (a ? l(r, d, n) : l(n)) || n);
  return a && n && g(r, d, n), n;
};
class t extends u(x) {
  constructor() {
    super(...arguments), this.checked = !1, this.type = "checkbox", this.required = !1, this.disabled = !1, this.dirty = !1;
  }
  static {
    this.styles = b(y);
  }
  static {
    this.formControlValidators = m;
  }
  connectedCallback() {
    super.connectedCallback(), this.addEventListener("invalid", this.#t);
  }
  disconnectedCallback() {
    super.disconnectedCallback(), this.removeEventListener("invalid", this.#t);
  }
  #t() {
    this.dirty = !0;
  }
  #r(r) {
    this.dirty = !0, this.checked = r.target.checked, this.onChange.emit(this.checked, { bubbles: !0 });
  }
  validityCallback() {
    return this.onInvalid.emit(this.internals.validity), this.validationTarget?.validationMessage;
  }
  async updated(r) {
    (r.has("value") || r.has("checked")) && (this.setValue(this.checked ? this.value : null), await this.validationComplete, this.requestUpdate());
  }
  resetFormControl() {
    this.dirty = !1, this.checked = this.hasAttribute("checked");
  }
  focus() {
    this.validationTarget.focus();
  }
  #n() {
    return c`<dfx-label type="error" id="label">${this.validationMessage}</dfx-label>`;
  }
  #o() {
    return this.helperText ? c`<dfx-label type="helper" id="label">${this.helperText}</dfx-label>` : c``;
  }
  /** @ignore */
  get #e() {
    return !this.validity.valid && this.dirty;
  }
  render() {
    return c`
      <label part="container" class=${this.#e ? "invalid" : i}>
        <input
          part="input"
          type="checkbox"
          .checked=${k(this.checked)}
          name=${this.name ?? i}
          value=${this.value ?? i}
          role=${this.type === "switch" ? "switch" : i}
          ?required=${this.required}
          ?disabled=${this.disabled}
          @change=${this.#r}
          aria-describedby=${this.helperText || this.#e ? "label" : i}
        />
        <div part="label">
          <slot></slot>
          ${this.#e ? this.#n() : this.#o()}
        </div>
      </label>
    `;
  }
}
e([
  p("input")
], t.prototype, "validationTarget", 2);
e([
  o({ type: Boolean })
], t.prototype, "checked", 2);
e([
  o({ type: String, reflect: !0 })
], t.prototype, "name", 2);
e([
  o({ type: String })
], t.prototype, "value", 2);
e([
  o({ type: String, reflect: !0 })
], t.prototype, "type", 2);
e([
  o({ type: Boolean, reflect: !0 })
], t.prototype, "required", 2);
e([
  o({ type: Boolean, reflect: !0 })
], t.prototype, "disabled", 2);
e([
  o({ type: String, attribute: "helper-text", reflect: !0 })
], t.prototype, "helperText", 2);
e([
  f("dfx-change")
], t.prototype, "onChange", 2);
e([
  f("dfx-invalid")
], t.prototype, "onInvalid", 2);
e([
  v()
], t.prototype, "dirty", 2);
export {
  t as Checkbox
};
//# sourceMappingURL=checkbox.js.map
