import { LitElement as a, unsafeCSS as i, html as s } from "lit";
import { property as d } from "lit/decorators.js";
const h = `:host {
  display: block;
  color: var(--dfx-label-color);
  font-family: var(--dfx-label-font-family);
  font-size: var(--dfx-label-font-size);
  line-height: var(--dfx-label-line-height);
  font-weight: var(--dfx-label-font-weight);

  --dfx-label-font-family: var(
    --dfx-font-family,
    -apple-system,
    BlinkMacSystemFont,
    'Segoe UI',
    Roboto,
    Arial,
    sans-serif
  );
}

:host([hidden]) {
  display: none;
}

:host([type='control']) {
  --dfx-label-color: var(--dfx-color-text-dark, #383d46);
  --dfx-label-font-size: var(--dfx-font-size-m, 0.875rem);
  --dfx-label-font-weight: var(--dfx-font-weight-semibold, 600);
  --dfx-label-line-height: var(--dfx-line-height-m, 1.5);
}

:host([type='error']) {
  --dfx-label-color: var(--dfx-color-danger-dark, #c91f3a);
  --dfx-label-font-size: var(--dfx-font-size-s, 0.75rem);
  --dfx-label-font-weight: var(--dfx-font-weight-regular, 400);
  --dfx-label-line-height: var(--dfx-line-height-m, 1.5);
}

:host([type='helper']) {
  --dfx-label-color: var(--dfx-color-text-light, #676f7d);
  --dfx-label-font-size: var(--dfx-font-size-s, 0.75rem);
  --dfx-label-font-weight: var(--dfx-font-weight-regular, 400);
  --dfx-label-line-height: var(--dfx-line-height-m, 1.5);
}
`;
var x = Object.defineProperty, v = Object.getOwnPropertyDescriptor, p = (l, n, r, t) => {
  for (var e = t > 1 ? void 0 : t ? v(n, r) : n, o = l.length - 1, f; o >= 0; o--)
    (f = l[o]) && (e = (t ? f(n, r, e) : f(e)) || e);
  return t && e && x(n, r, e), e;
};
class b extends a {
  constructor() {
    super(...arguments), this.type = "control";
  }
  static {
    this.styles = i(h);
  }
  render() {
    return s`
      <div aria-live=${this.type === "error" ? "polite" : "off"}>
        <slot></slot>
      </div>
    `;
  }
}
p([
  d({ type: String, reflect: !0 })
], b.prototype, "type", 2);
export {
  b as Label
};
//# sourceMappingURL=label.js.map
