import { LitElement, TemplateResult } from 'lit';
/**
 * Symbolizes that user action is being processed.
 *
 * @element dfx-spinner
 * @cssprop [--dfx-spinner-color=currentColor] - Spinner color
 * @cssprop [--dfx-spinner-font-family=var(--dfx-font-family, -apple-system, BlinkMacSystemFont, 'Segoe UI', Roboto, Arial, sans-serif)] - Label font family
 * @cssprop [--dfx-spinner-font-size=var(--dfx-font-size-m, 0.875rem)] - Label font size
 * @cssprop [--dfx-spinner-gap=var(--dfx-size-2xs, 0.5rem)] - Gap between spinner and label
 * @cssprop [--dfx-spinner-line-height=var(--dfx-line-height-m, 1.5)] - Label line height
 * @cssprop [--dfx-spinner-padding=0] - Spinner padding
 * @cssprop [--dfx-spinner-size=var(--dfx-size-2xl, 2rem)] - Spinner size
 */
export declare class Spinner extends LitElement {
    static styles: import("lit").CSSResult;
    /**
     * Sets size of the spinner
     */
    size: 'small' | 'medium' | 'large';
    /**
     * Sets label of the spinner
     */
    label: string;
    render(): TemplateResult;
}
//# sourceMappingURL=spinner.d.ts.map