import { LitElement as x, unsafeCSS as c, html as o, nothing as i } from "lit";
import { query as u, property as r, state as v } from "lit/decorators.js";
import { live as b } from "lit/directives/live.js";
import { FormControlMixin as m } from "@open-wc/form-control";
import { event as p } from "../../utils/event.js";
import { innerInputValidators as g } from "../../utils/validators.js";
import "../label/index.js";
const y = `:host {
  display: inline-block;
  width: var(--dfx-textarea-width);

  --dfx-textarea-border-radius: var(--dfx-border-radius-m, 0.375rem);
  --dfx-textarea-color-background: var(--dfx-color-background-light, #ffffff);
  --dfx-textarea-color-text: var(--dfx-color-text-dark, #383d46);
  --dfx-textarea-font-family: var(
    --dfx-font-family,
    -apple-system,
    BlinkMacSystemFont,
    'Segoe UI',
    Roboto,
    Arial,
    sans-serif
  );
  --dfx-textarea-font-size: var(--dfx-font-size-m, 0.875rem);
  --dfx-textarea-gap: var(--dfx-size-2xs, 0.5rem);
  --dfx-textarea-height: auto;
  --dfx-textarea-line-height: var(--dfx-line-height-m, 1.5);
  --dfx-textarea-padding: var(--dfx-size-2xs, 0.5rem) var(--dfx-size-xs, 0.75rem);
  --dfx-textarea-transition: all var(--dfx-transition-medium, 0.2s ease-in-out);
  --dfx-textarea-width: calc(var(--dfx-size-3xl, 2.5rem) * 5);
}

:host([hidden]) {
  display: none;
}

:host([disabled]) [part='container'] {
  --dfx-textarea-color-background: var(--dfx-color-background-light-variant, #f0f2f4);
  --dfx-textarea-color-text: var(--dfx-color-text-light, #676f7d);
  opacity: var(--dfx-form-disabled-opacity, 0.5);
  cursor: not-allowed;
}

:host([disabled]) textarea {
  pointer-events: none;
}

[part='container'] {
  display: grid;
  gap: var(--dfx-textarea-gap);
}

textarea {
  width: 100%;
  box-sizing: border-box;
  height: var(--dfx-textarea-height);
  padding: var(--dfx-textarea-padding);
  font-family: var(--dfx-textarea-font-family);
  color: var(--dfx-textarea-color-text);
  font-size: var(--dfx-textarea-font-size);
  line-height: var(--dfx-textarea-line-height);
  background-color: var(--dfx-textarea-color-background);
  border-radius: var(--dfx-textarea-border-radius);
  box-shadow: var(--dfx-form-border, inset 0 0 0 0.05rem #979fab);
  transition: var(--dfx-textarea-transition);
  resize: vertical;
  border: none;
  outline: 0;
  margin: 0;

  &:focus-visible {
    box-shadow: var(--dfx-form-border-active, inset 0 0 0 0.1rem #20242c);
  }

  &::placeholder {
    color: var(--dfx-color-text-dark-variant, #20242c);
    opacity: var(--dfx-form-disabled-opacity, 0.5);
  }
}

.invalid textarea {
  box-shadow: var(--dfx-form-border-error, inset 0 0 0 0.05rem #c91f3a);
}

.invalid textarea:focus-visible {
  box-shadow: var(--dfx-form-border-error-active, inset 0 0 0 0.1rem #c91f3a);
}

::-webkit-resizer {
  background-image: url('data:image/svg+xml, <svg xmlns="http://www.w3.org/2000/svg" fill="none" viewBox="0 0 24 24"><path d="M7 18L18 7M13 18L18 13" stroke="%239ca3af" stroke-width="1.5" stroke-linecap="round" stroke-linejoin="round"/></svg>');
}

.description {
  display: grid;
  grid-template-columns: 1fr auto;
  gap: var(--dfx-textarea-gap);

  #character-count {
    grid-column: 2;
  }
}
`;
var $ = Object.defineProperty, w = Object.getOwnPropertyDescriptor, e = (d, a, s, l) => {
  for (var n = l > 1 ? void 0 : l ? w(a, s) : a, h = d.length - 1, f; h >= 0; h--)
    (f = d[h]) && (n = (l ? f(a, s, n) : f(n)) || n);
  return l && n && $(a, s, n), n;
};
class t extends m(x) {
  constructor() {
    super(...arguments), this.value = "", this.rows = 3, this.required = !1, this.disabled = !1, this.readonly = !1, this.hideLabel = !1, this.spellchecker = !1, this.characterCounter = !1, this.dirty = !1, this.#t = Math.random().toString(36).substring(2);
  }
  static {
    this.styles = c(y);
  }
  static {
    this.formControlValidators = g;
  }
  connectedCallback() {
    super.connectedCallback(), this.addEventListener("invalid", this.#r);
  }
  disconnectedCallback() {
    super.disconnectedCallback(), this.removeEventListener("invalid", this.#r);
  }
  #r() {
    this.dirty = !0;
  }
  #a(a) {
    this.value = a.target.value, this.onInput.emit(this.value);
  }
  #i(a) {
    this.dirty = !0, this.value = a.target.value, this.onChange.emit(this.value);
  }
  validityCallback() {
    return this.onInvalid.emit(this.internals.validity), this.validationTarget?.validationMessage;
  }
  async updated(a) {
    a.has("value") && (this.setValue(this.value), await this.validationComplete, this.requestUpdate());
  }
  resetFormControl() {
    this.dirty = !1, this.value = this.getAttribute("value") ?? "";
  }
  #n() {
    return o`<dfx-label type="error" id="label">${this.validationMessage}</dfx-label>`;
  }
  #o() {
    return this.helperText ? o`<dfx-label type="helper" id="label">${this.helperText}</dfx-label>` : o``;
  }
  #l() {
    return o`<label for=${this.#t}><dfx-label>${this.label}</dfx-label></label>`;
  }
  #d() {
    return o`
      <dfx-label type=${this.#e ? "error" : "helper"} id="character-count">
        ${this.value.length}${this.maxlength ? "/" + this.maxlength : i}
      </dfx-label>
    `;
  }
  /** @ignore */
  get #e() {
    return !this.validity.valid && this.dirty;
  }
  #t;
  render() {
    return o`
      <div part="container" class=${this.#e ? "invalid" : i}>
        ${this.label && !this.hideLabel ? this.#l() : i}
        <textarea
          id=${this.#t}
          part="textarea"
          .value=${b(this.value)}
          rows="${this.rows}"
          placeholder="${this.placeholder ?? i}"
          minlength="${this.minlength ?? i}"
          maxlength="${this.maxlength ?? i}"
          ?required=${this.required}
          ?disabled=${this.disabled}
          ?readonly=${this.readonly}
          spellcheck="${this.spellchecker}"
          @change=${this.#i}
          @input=${this.#a}
          aria-label=${this.label && this.hideLabel ? this.label : i}
          aria-invalid=${this.#e}
          aria-describedby=${this.helperText || this.#e ? "label" : i}
        ></textarea>
        <div class="description">
          ${this.#e ? this.#n() : this.#o()}
          ${this.characterCounter ? this.#d() : i}
        </div>
      </div>
    `;
  }
}
e([
  u("textarea")
], t.prototype, "validationTarget", 2);
e([
  r({ type: String, reflect: !0 })
], t.prototype, "name", 2);
e([
  r({ type: String })
], t.prototype, "value", 2);
e([
  r({ type: String, reflect: !0 })
], t.prototype, "label", 2);
e([
  r({ type: Number, reflect: !0 })
], t.prototype, "rows", 2);
e([
  r({ type: String, reflect: !0 })
], t.prototype, "placeholder", 2);
e([
  r({ type: Boolean, reflect: !0 })
], t.prototype, "required", 2);
e([
  r({ type: Number, reflect: !0 })
], t.prototype, "minlength", 2);
e([
  r({ type: Number, reflect: !0 })
], t.prototype, "maxlength", 2);
e([
  r({ type: Boolean, reflect: !0 })
], t.prototype, "disabled", 2);
e([
  r({ type: Boolean, reflect: !0 })
], t.prototype, "readonly", 2);
e([
  r({ type: String, attribute: "helper-text", reflect: !0 })
], t.prototype, "helperText", 2);
e([
  r({ type: Boolean, attribute: "hide-label", reflect: !0 })
], t.prototype, "hideLabel", 2);
e([
  r({ type: Boolean, reflect: !0 })
], t.prototype, "spellchecker", 2);
e([
  r({ type: Boolean, attribute: "character-counter", reflect: !0 })
], t.prototype, "characterCounter", 2);
e([
  p("dfx-input")
], t.prototype, "onInput", 2);
e([
  p("dfx-change")
], t.prototype, "onChange", 2);
e([
  p("dfx-invalid")
], t.prototype, "onInvalid", 2);
e([
  v()
], t.prototype, "dirty", 2);
export {
  t as Textarea
};
//# sourceMappingURL=textarea.js.map
